(function ($, Drupal) {
    Drupal.behaviors.color = {
        attach: function attach(context, settings) {

            var farbzone = $(context).find('#orejime-settings #color-zone').once('color');
            var form = $(context).find('#orejime-settings .color-form').once('color');
            if (farbzone.length === 0) {
                return;
            }
            var focused = null;

            $('<div class="color-placeholder"></div>').once('color').prependTo(farbzone);
            var farb = $.farbtastic('.color-placeholder');

            var reference = settings.color;
            Object.keys(reference || {}).forEach(function (color) {
                if(color != 'enable' && color !='btn_radius' && color !='url_css')
                    reference[color] = farb.RGBToHSL(farb.unpack(reference[color]));
            });

            function resetScheme() {
                form.find('#edit-scheme').each(function () {
                    this.selectedIndex = this.options.length - 1;
                });
            }


            function callback(input, color, propagate, colorScheme) {
                $(input).css({
                    backgroundColor: color,
                    color: farb.RGBToHSL(farb.unpack(color))[2] > 0.5 ? '#000' : '#fff'
                });

                if ($(input).val() && $(input).val() !== color) {
                    $(input).val(color);

                    if (!colorScheme) {
                        resetScheme();
                    }
                }
            }

            function focus(e) {
                var input = e.target;
                focused = input;
                farb.linkTo(function (color) {
                    callback(input, color, true, false);
                });
                farb.setColor(input.value);
            }
            form.find('.js-color-palette').each(function () {
                this.key = this.id.substring(13);
                farb.linkTo(function () {}).setColor('#000').linkTo(this);

            }).on('focus', focus);

            form.find('.js-color-palette label');
        }
    };
})(jQuery, Drupal);
